--[[
--Elimination v1.0
--By Darren Watts (W'rkncacnter)
--]]

spawns = {}
timer = {}
score = {}
waiting = {}
just_reset = true
reset_timer = 90
TIMER_INIT_AMT = 600
TIMER_AMOUNT = 450
last_player_to_die = -1
about_to_reset_timer = 0 --Delays reset in check_if_round_over to give the player_killed resets priority.
able_to_win = {}
disconnected = {}
team = false;
timer_on = false;

color_go = [[
2
#111111
&00ff00
]]

color_wait = [[
2
#111111
&ff0000
]]

icon_shape = [[
#####&&&&&&#####
####&&&&&&&&####
##&&&&&&&&&&&&##
#&&&&&&&&&&&&&&#
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
&&&&&&&&&&&&&&&&
#&&&&&&&&&&&&&&#
##&&&&&&&&&&&&##
##&&&&&&&&&&&&##
####&&&&&&&&####
#####&&&&&&#####
]]

function init()
	for i = 1, number_of_players(), 1 do
		spawns[i] = get_player_polygon(i-1)
		timer[i] = TIMER_INIT_AMT
		score[i] = 0
		waiting[i] = false
		able_to_win[i] = true
		disconnected[i] = false
	end
	for i = 1, number_of_players(), 1 do
		if (get_player_color(i-1) ~= get_player_team(i-1)) then
			teams = true;
			break;
		end
	end
	for i = 1, number_of_players(), 1 do
		set_player_color(i-1, get_player_team(i-1));
	end
	if(get_game_type() == _game_of_king_of_the_hill) then
		timer_on = true
	else
		timer_on = false
	end
end

function idle()
	set_score()
	update_reset_timer()
	update_timer()
	check_if_round_over()
	player_stays_dead()
	disconnected_players()
	use_radar()
	use_overlay()
end

function set_score()
	for i = 0, number_of_players() - 1, 1 do
		set_points(i, score[i+1])
	end
end

function update_reset_timer()
	if(reset_timer > 0) then
		reset_timer = reset_timer - 1
	else
		just_reset = false
	end
	if(about_to_reset_timer > 0) then
		about_to_reset_timer = about_to_reset_timer - 1
	end
end

function update_timer()
	for i = 0, number_of_players() - 1, 1 do
		if(get_polygon_type((get_player_polygon(i))) == _polygon_is_hill and
			timer[i+1] <= TIMER_AMOUNT and not player_is_dead(i)) then
			timer[i+1] = TIMER_AMOUNT
		elseif(waiting[i+1]) then
			timer[i+1] = TIMER_INIT_AMT
		elseif(timer[i+1] > 0) then
			timer[i+1] = timer[i+1] - 1
		end
	end
end

function check_if_round_over()
	for i = 0, number_of_players() - 1, 1 do
		if(timer[i+1] == 0 and not only_one_not_waiting(i) and timer_on) then
			inflict_damage(i, 1000)
		elseif(about_to_reset_timer == 0 and only_one_not_waiting(i) 
			and able_to_win[i+1] and not just_reset) then
			reset(i)
		elseif(about_to_reset_timer == 0 and only_one_not_waiting(i) 
			and able_to_win[last_player_to_die+1] and not just_reset) then
			reset(last_player_to_die)
		elseif(about_to_reset_timer == 0 and only_one_not_waiting(i) 
			and not able_to_win[i+1] and not able_to_win[last_player_to_die+1] and not just_reset) then
			reset(-1)
		end
		if(teams and about_to_reset_timer == 0 and not just_reset
		and only_team_standing(get_player_team(i))) then
			reset(i)
			break
		end
	end
end

function player_stays_dead()
	for i = 0, number_of_players() - 1, 1 do
		if(player_is_dead(i) and timer[i+1] == 0) then
			waiting[i+1] = true
		end
	end
end

function disconnected_players()
	for i = 1, table.getn(disconnected), 1 do
		if(disconnected[i] == true) then
			waiting[i] = true
		end
	end
end

function player_killed(player, aggressor_player, action, projectile)
	if(just_reset) then
		return
	end
	local only_team_survives = false;
	if (teams and aggressor_player ~= -1) then
		local a_team = get_player_team(aggressor_player);
		only_team_survives = only_team_standing(a_team);
	end
	local was_waiting = false
	if(waiting[player+1] == true) then
		was_waiting = true
	end
	waiting[player+1] = true
	about_to_be_reset_timer = 5
	
	--Player did not commit suicide, round still continues
	if(player ~= aggressor_player and (not only_one_not_waiting(player) or not only_team_survives)) then 
		last_player_to_die = player
		if(not was_waiting and not only_one_not_waiting(aggressor_player)) then
			screen_print(get_player_name(player).." has been eliminated from the round!")
		end
		
	--Player did not commit suicide, but was suicided against.  Last person to die, so wins.
	elseif(player ~= aggressor_player
	and ((only_one_not_waiting(player) or only_team_survives)
		and not just_reset)) then
		last_player_to_die = player
		reset(player)
		
	--Player suicides, round continues
	elseif(player == aggressor_player and not only_one_not_waiting(player)) then
		able_to_win[player+1] = false
		screen_print(get_player_name(player).." has been eliminated from the round!")
		
	--Player suicides, and everyone is dead. round ends
	elseif(player == aggressor_player and (only_one_not_waiting(player) or only_team_survives)
		and not just_reset) then 
		able_to_win[player+1] = false
		if(able_to_win[last_player_to_die+1]) then
			reset(last_player_to_die)
		else
			reset(-1)
		end
	end
end

function player_damaged(victim_player_index, aggressor_player_index, aggressor_monster_index, damage_type, damage_amount, projectile)
	if(damage_type == _damage_fusion and aggressor_monster_index == -1) then
		disconnected[victim_player_index+1] = true
	end
end

function player_revived(player)
	disconnected[player+1] = false
	if(waiting[player+1]) then
		inflict_damage(player, 1000)
		award_kills (-1, player, -1)
		screen_print(player, "You must wait until this round is over!")
	else
		able_to_win[player+1] = true
	end
end

function reset(player)
	just_reset = true
	reset_timer = 90
	if(player == -1) then
		screen_print("No one wins this round!")
	else
		if(not teams) then
			screen_print(get_player_name (player).." wins the round!")
		else
			print_winning_team(get_player_team(player))
		end
		score[player+1] = score[player+1] + 30
		local poly = math.mod (better_random (), table.getn(spawns))
		if(not teams) then
			teleport_player (player, spawns[poly+1])
		end
	end
	for i = 0, number_of_players() - 1, 1 do
		timer[i+1] = TIMER_INIT_AMT
		waiting[i+1] = false
		if(player_is_dead(i)) then
			able_to_win[i+1] = false
		end
		if(get_life(i) < 150) then
			set_life(i, 150)
		end
	end
end

function use_radar()
	if(not timer_on) then
		use_lua_compass(true)
		set_lua_compass_state (local_player_index(), _network_compass_all_off)
	end
end

function use_overlay()
	local players_left = 0
	for i = 0, number_of_players() - 1, 1 do
		if(able_to_win[i+1] and not player_is_dead(i)) then players_left = players_left + 1 end
	end
	local icon = nil
	local time_amount = math.floor(timer[local_player_index() + 1] / 30)
	
	--No teams and a timer.
		--Overlay 0 is the timer.
		--Overlay 1 is the # of players left.
	if(not teams and timer_on) then
		if(time_amount > 10) then
			set_overlay_color(0, 0)
		elseif(time_amount > 5) then
			set_overlay_color(0, 5)
		else set_overlay_color(0, 2)
		end
		if(timer_on) then
			set_overlay_text(0, time_amount)
		end
		
		set_overlay_color(1, 0)
		set_overlay_text(1, "Plrs Left: "..players_left)
	
	--Teams with a timer.
		--Overlay 0 is the timer.
		--Overlay 1 is tms/tmates/plrs.
		--Overlay 2 is blank for spacing.
	elseif(teams and timer_on) then
		if(time_amount > 10) then
			set_overlay_color(0, 0)
		elseif(time_amount > 5) then
			set_overlay_color(0, 5)
		else set_overlay_color(0, 2)
		end
		if(timer_on) then
			set_overlay_text(0, time_amount)
		end
		
		set_overlay_color(1, 0)
		set_overlay_text(1, "Tms/Tmates/Plrs: "..get_teams_left().."/"..get_teammate_num().."/"..players_left)
		
		set_overlay_color(2, 0)
		set_overlay_text(2, " ")
	
	--No teams and no timer.
		--Overlay 0 is # of players left.
	elseif(not teams and not timer_on) then
		set_overlay_color(0, 0)
		set_overlay_text(0, "Plrs Left: "..players_left)
	
	--Teams and no timer.
		--Overlay 0 is tms/tmates/plrs.
		--Overlay 1 is blank for spacing.
	elseif(teams and not timer_on) then
		set_overlay_color(0, 0)
		set_overlay_text(0, "Tms/Tmates/Plrs: "..get_teams_left().."/"..get_teammate_num().."/"..players_left)
		set_overlay_color(1, 0)
		set_overlay_text(1, " ")
	end	
	
	--This icon overlay is the same for any case.
	if(player_is_dead(local_player_index()) and waiting[local_player_index() +1]) then
		icon = color_wait .. icon_shape
		set_overlay_icon(5, icon)
		set_overlay_color(5, 0)
		set_overlay_text(5, " ")
	elseif(player_is_dead(local_player_index()) and not waiting[local_player_index() +1]) then
		icon = color_go .. icon_shape
		set_overlay_icon(5, icon)
		set_overlay_color(5, 0)
		set_overlay_text(5, " ")
	elseif(not player_is_dead(local_player_index())) then
		set_overlay_text(5, "")
	end
end

function only_one_not_waiting(player)
	for i = 0, number_of_players() - 1, 1 do
		if(player == i) then do_nothing()
		elseif(waiting[i+1] == false) then return false
		end
	end
	return true
end

function do_nothing() end

function print_winning_team(a_team)
	if(a_team == 0) then
		screen_print("Slate team wins the round!");
	elseif(a_team == 1) then
		screen_print("Red team wins the round!");
	elseif(a_team == 2) then
		screen_print("Purple team wins the round!");
	elseif(a_team == 3) then
		screen_print("Yellow team wins the round!");
	elseif(a_team == 4) then
		screen_print("White team wins the round!");
	elseif(a_team == 5) then
		screen_print("Orange team wins the round!");
	elseif(a_team == 6) then
		screen_print("Blue team wins the round!");
	elseif(a_team == 7) then
		screen_print("Green team wins the round!");
	end
end

function get_teams_left()
	local teams = {}
	for i = 0, number_of_players() - 1, 1 do
		if(not player_is_dead(i)) then
			local team = get_player_team(i)
			if(table.getn(teams) == 0) then
				teams[1] = team
			end
			for k = 1, table.getn(teams), 1 do
				if(teams[k] == team) then
					break
				elseif(teams[k] ~= team and k == table.getn(teams)) then
					teams[table.getn(teams)+1] = team
				end
			end
		end
	end
	return table.getn(teams)
end

function get_teammate_num()
	local teammates = 0
	for i = 0, number_of_players() - 1, 1 do
		if(get_player_team(local_player_index()) == get_player_team(i) and
		able_to_win[i+1] and not player_is_dead(i)) then
			teammates = teammates + 1
		end
	end
	return teammates
end

--irons code:
function only_team_standing(a_team)
	local all = true;
	local lupe;
	for lupe = 1, number_of_players(), 1 do
		local l_team = get_player_team(lupe - 1);
		if(not waiting[lupe]) then
			if (l_team ~= a_team) then
				all = false;
				break;
			end
		end
	end
	return all;
end